program hyb

use omp_lib
#ifdef MPI
use mpi
#endif
implicit none
integer :: err, provided, i, j
integer, parameter :: n=100000
real, allocatable :: v(:)

allocate(v(n)) ; v = 0.

#ifdef MPI
call MPI_Init_thread(MPI_THREAD_FUNNELED, provided, err)
if(provided /= MPI_THREAD_FUNNELED) then
    call MPI_Finalize(err)
    STOP "MPI_THREAD_FUNNELED NOT AVAIALBLE"
else 
    print *, "provided: ",provided
endif

#endif
do j=1,1000
!$omp parallel do
do i=1,n
    v(i) = v(i) + sin(cos(sin(float(i)**0.2)**0.3)**0.4)
enddo
!$omp end parallel do
enddo
!$omp parallel
!$omp critical
print*,"OMP omp_get_thread_num(): ",omp_get_thread_num()
print*,"v(3):  ",v(3)
!$omp end critical
!$omp end parallel
#ifdef MPI
call MPI_Finalize(err)
#endif

end program hyb
